// 002 u_udf_string
// 21 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)


unit u_udf_string;
  interface
    uses SysUtils, Windows, Classes;

    function f_trim_right(p_pchar: PChar): PChar; cdecl; export;
    function f_right_pad(p_pchar: PChar; var pv_target_length: Integer; p_pad_pchar: PChar): PChar; cdecl; export;
    function f_string_length(p_pchar: PChar): Integer; cdecl; export;
    function f_sub_string(p_pchar: PChar; VAR pv_position, pv_length: Integer): PChar; cdecl; export;

  implementation
    uses u_udf_globals;

    function f_trim_right(p_pchar: PChar): PChar;
      begin
        Result:= f_build_pchar(PChar(TrimRight(String(p_pchar))), nil, 0);
      end; // f_trim_right

    function f_right_pad(p_pchar: PChar; var pv_target_length: Integer; p_pad_pchar: PChar): PChar; cdecl; export;
        // -- complement the string to the right up to the desired length
        // --   ? why is the length a VAR param
      var l_string, l_padded_string: String;
          l_padded_length, l_length, l_index: Integer;
      begin
        l_string:= String(p_pchar);
        l_length:= Length(l_string);
        l_padded_string:= String(p_pad_pchar);
        l_padded_length:= Length(l_padded_string);

        if (l_length< pv_target_length) and (l_padded_length<= pv_target_length- l_length)
          then
            begin
              // -- if padding is a string, can return a string longer than pv_target_length
              for l_index:= 1 to (pv_target_length- l_length) div l_padded_length do
                l_string:= l_string+ l_padded_string;
            end;

        Result:= f_build_pchar(PChar(l_string), nil, 0);
      end; // f_right_pad

    function f_string_length(p_pchar: PChar): Integer;
      begin
        Result:= StrLen(p_pchar);
      end; // f_string_length

    function f_SubStr(p_pchar: PChar; p_position, p_length: Integer): PChar; cdecl; export;
      var l_string, l_substring: String;
      begin
        l_string:= String(p_pchar);
        l_substring:= Copy(l_string, p_position, p_length);
        Result:= f_build_pchar(PChar(l_substring), nil, 0);
      end; // f_sub_string

    function f_sub_string(p_pchar: PChar; VAR pv_position, pv_length: Integer): PChar; cdecl; export;
      var l_string, l_substring: String;
      begin
        l_string:= String(p_pchar);
        l_substring:= Copy(l_string, pv_position, pv_length);
        Result:= f_build_pchar(PChar(l_substring), nil, 0);
      end; // f_sub_string

    end.
